{  simg -- command line applications for deterministic image processing
   Version 20220317
   Copyright (C) 1999-2022 Stefan Ziegenbalg
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 3 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see http://www.gnu.org/licenses/.
!}

{@name power}
{@description Computes power of an image (exponentiation)}

{$I directives.pas}
uses simage,getparam;
var par        : tparams;
    cc         : CSImg_Config;
    img        : TSImg_FPImage;
    ex         : double;
    fi,fo      : ansistring;

begin
    with par do
    begin
        init;
        paramusage:='[<infile> [<outfile>]]';
        fi:='';     defparam('<infile>','Input image (default: stdin)',fi);
        fo:='';     defparam('<outfile>','Output image (default: stdout)',fo);
        ex:=2;      defparam('-e','Exponent',ex);
                    defparam('-h','Help',helpf);
                    defparam('-o','Output image',fo); deffmt('-o','<outfile>');
        run;
        done;
    end;
    cc:=CSImg_Config.create(SImg_Config_Default);
    cc.debug('power: values: source='+fi+' dest='+fo+' e='+real2str(ex));

    cc.Info('power: Reading input image '+fi);
    SImg_ReadImageFile(cc,fi,img);

    cc.Info('power: Calculating power');
    SImg_Power(cc,img,img, ex);

    cc.Info('power: Writing output image '+fo);
    SImg_WriteImageFile(cc,fo,img);
    SImg_Free(cc,img);

    cc.destroy;
end.
