{  simg -- image processing library
   Version 20220317
   Copyright (C) 1999-2022 Stefan Ziegenbalg
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 3 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see http://www.gnu.org/licenses/.
!}

unit compatun;

interface
function stimer:double;                 { gets time in s since unspecified starting point, not taking into account the suspension time or clock adjustments }
procedure delay(t:longint);             { wait time in ms }

implementation
uses baseunix,unix,linux;

function stimer:double;
var tv  : timespec;
begin
    clock_gettime(CLOCK_MONOTONIC_RAW,@tv);
    stimer:=tv.tv_sec + tv.tv_nsec*1e-9;
end;

procedure delay(t:longint);
var req,rem : timespec;
begin
    if t<0 then exit;
    req.tv_sec:=t div 1000;
    req.tv_nsec:=(t mod 1000)*1000000;
    fpnanosleep(@req,@rem);
end;

end.
